#ifndef CONJUGATE_M_NORMAL_H_
#define CONJUGATE_M_NORMAL_H_

#include <sampler/ConjugateSampler.h>

/**
 * Conjugate sampler for multivariate normal distribution
 *
 * ConjugateMNormal is currently rather limited in scope.  It can
 * sample a multivariate normal node "snode" if all the informative
 * stochastic children of snode are themselves multivariate normal,
 * with mean snode, and where the precision matrix does not depend on
 * snode.
 *
 * This can (and should) be extended to allow informative marginal
 * stochastic children that are normally distribution and where the
 * mean of the children is a linear function of (some element of)
 * snode.
 */
class ConjugateMNormal : public ConjugateSampler {
 public:
	ConjugateMNormal(StochasticNode *snode);
	~ConjugateMNormal();

	static bool canSample(StochasticNode const *snode);
	void update();
};

#endif /* CONJUGATE_M_NORMAL_H_ */
