## The data transformation step must be done outside of JAGS
## The code has been translated to R. Invoke with
## R --vanilla < data-transform.R
## and this will create a new datafile "leuk-data2.R"

source("leuk-data.R")

Y <- dN <- matrix(0, nrow=N, ncol=T)
for(i in 1:N) {
    for(j in 1:T) {
        ## risk set = 1 if obs.t >= t
        Y[i,j] <- (obs.t[i] - t[j] + eps) > 0
        
        ## counting process jump = 1 if obs.t in [ t[j], t[j+1] )
        ##                      i.e. if t[j] <= obs.t < t[j+1]
        dN[i,j] <- Y[i,j]*fail[i] * ((t[j+1] - obs.t[i] - eps) > 0)
    }
}
dump(c("Y","dN"), file="leuk-data2.R")

